accounts/urls.py
"""" Defining URL patterns for registration. """

from django.urls import path
from django.contrib.auth.views import PasswordChangeView, PasswordChangeDoneView

from accounts.views import SignUpView, MyAccountView, SignUpDetailView, MyAccountDetailView

app_name = 'accounts'

urlpatterns = [
    # Sign Up
    path('registration/', SignUpView.as_view(), name='registration'),
    # Sign Up detail
    path('registration_detail/<int:id>/', SignUpDetailView.as_view(), name='registration_detail'),

    # Account edit
    path('my_account/', MyAccountView.as_view(), name='my_account'),
    # Account detail edit
    path('my_account_detail/', MyAccountDetailView.as_view(), name='my_account_detail'),


    # Password change
    path('password_change/', PasswordChangeView.as_view(template_name='registration/password_change.html'),
         name='password_change'),
    # Password change confirmation
    path('password_change_done/', PasswordChangeDoneView.as_view(template_name='registration/password_change_done.html'),
         name='password_change_done'),
]

club/urls.py
""" Defining URL patterns for registration. """

from django.urls import path

from club.views import ClubView, \
    ActualitiesView, ActualityDetailView, ActualityCreateView, ActualityEditView, \
    DiscussionsView, DiscussionDetailView, DiscussionCreateView, DiscussionEditView, DiscussionReactionView

app_name = 'club'

urlpatterns = [
    # Club main page
    path('', ClubView.as_view(), name='club'),

    # Actualities topics page
    path('actualities/', ActualitiesView.as_view(), name='actualities'),
    # Actuality detail
    path('actuality/<int:id>/', ActualityDetailView.as_view(), name='actuality'),
    # Create new actuality
    path('new_actuality/', ActualityCreateView.as_view(), name='new_actuality'),
    # Edit actuality
    path('edit_actuality/<int:id>/', ActualityEditView.as_view(), name='edit_actuality'),

    # Discussion themes page
    path('discussions/', DiscussionsView.as_view(), name='discussions'),
    # Discussion theme detail
    path('discussion/<int:id>/', DiscussionDetailView.as_view(), name='discussion'),
    # Create new discussion
    path('new_discussion/', DiscussionCreateView.as_view(), name='new_discussion'),
    # Edit discussion theme
    path('edit_discussion/<int:id>/', DiscussionEditView.as_view(), name='edit_discussion'),
    # Reaction on theme in discussion
    path('reaction_discussion/<int:id>/', DiscussionReactionView.as_view(), name='reaction_discussion'),

]

final_project/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from warehouse.views import IndexView

urlpatterns = [
    path('admin/', admin.site.urls),

    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('accounts/', include('django.contrib.auth.urls')),

    path('club/', include('club.urls', namespace='club')),

    path('warehouse/', include('warehouse.urls', namespace='warehouse')),

    path('', IndexView.as_view(), name='index'),
]

urlpatterns += (static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
                + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
                )

warehouse/urls.py
from django.contrib.staticfiles.storage import staticfiles_storage
from django.urls import path
from django.views.generic import RedirectView

from warehouse.views import ReservationCreateView, ReservationItemsCreateView, WeekTableView, SuccessView, RentalDetailView, \
    RentalViewFilter

app_name = 'warehouse'

urlpatterns = [
    # Timetable for reservation
    path('week_table/', WeekTableView.as_view(), name='week_table'),

    # Create reservation
    path('reservation_create/<slug:requested_date>/<str:requested_time>/<str:capacity>/', ReservationCreateView.as_view(), name='reservation_create'),
    # Add item to a reservation
    path('item_reservation/<int:reservation>/', ReservationItemsCreateView.as_view(), name='item_reservation'),
    # Confirmation of reservation
    path('reservation_success/<int:reservation>/', SuccessView.as_view(), name='reservation_success'),

    # Rental review
    path('rental_list/', RentalViewFilter.as_view(), name='rental_list'),
    # Rental detail
    path('rental_detail/<int:pk>/', RentalDetailView.as_view(), name='rental_detail'),

    # Favicon
    # path('favicon.ico', RedirectView.as_view(url=staticfiles_storage.url('favicon/favicon.ico'))),
]

warehouse/models.py
from django.db.models import (
    CharField,
    DateField,
    TextField,
    IntegerField,
    ImageField,
    TimeField,
    EmailField,
    BooleanField,
    ForeignKey,
    Model,
    SmallIntegerField,
    PROTECT,
    CASCADE,
)


# from warehouse.choices import ITEMS_TYPES, ITEMS_SIZES
from django.utils.html import mark_safe


class TimeTable(Model):
    date = DateField(auto_now=False, auto_now_add=False, null=False, blank=False)  # YYYY-MM-DD format
    start_time = TimeField(auto_now=False, auto_now_add=False, null=False, blank=False)
    end_time = TimeField(auto_now=False, auto_now_add=False, null=False, blank=False)
    #    turn = SmallIntegerField(choices=TURNS_TYPES, null=False, blank=False)
    capacity = SmallIntegerField(null=False, blank=False)

    @property
    def date_stime(self):
        return f"{self.date} {self.start_time}"

    def __str__(self):
        return f'{self.date} ({self.start_time})'

    def __repr__(self):
        return f'{self.date} ({self.start_time})'


class Category(Model):
    #    category = SmallIntegerField(choices=ITEMS_TYPES, null=False, blank=False)
    category = CharField(max_length=64, null=False, blank=False)

    def __str__(self):
        return f'{self.category}'


class Manufacturer(Model):
    m_name = CharField(max_length=64, null=False, blank=False)
    country = CharField(max_length=64, null=False, blank=False)
    m_description = TextField(blank=True)

    def __str__(self):
        return f"{self.m_name}"


class Item(Model):
    category = ForeignKey(Category, null=False, on_delete=PROTECT, related_name='items')
    name = CharField(max_length=64, null=False, blank=False)
    manufacturer = ForeignKey(Manufacturer, null=False, on_delete=PROTECT, related_name='manufacturers')
    #    size = SmallIntegerField(choices=ITEMS_SIZES, null=False, blank=False)
    stock = SmallIntegerField(null=False, blank=False)
    description = TextField(blank=True)
    image = ImageField(upload_to='product_image') # pokud stači jen jedna fotka -> jinak musi byt samostatná tabulka pro IMG
    is_active = BooleanField(default=True)
    price = IntegerField(null=False, blank=False)

    @property
    def item_description(self):
        return (
            f"{self.name} {self.image}, {self.manufacturer}, {self.category}"
            f"{self.stock}, {self.description}"
        )

    def __str__(self):
        return f'{self.name} - {self.category}'


class Reservation(Model):
    first_name = CharField(max_length=64, null=False, blank=False)
    last_name = CharField(max_length=64, null=False, blank=False)
    phone_number = CharField(max_length=32, default='', null=False, blank=False)
    email = EmailField(max_length=128, default='', null=False, blank=False)
    person_quantity = SmallIntegerField(null=False, blank=False)
    route_numbers = SmallIntegerField(null=False, blank=False)
    timeslot = ForeignKey(TimeTable, null=False, on_delete=PROTECT, related_name='reservations')

    @property
    def full_name(self):
        return f"{self.last_name} {self.first_name}"

    def __str__(self):
        return f'{self.full_name} [{self.timeslot}]'


class ReservationItems(Model):
    reservation = ForeignKey(Reservation, on_delete=CASCADE, related_name='items')
    item = ForeignKey(Item, null=False, on_delete=PROTECT) # related_name='reserved_item' -> zatim bez tohoto, mozna nebudu potrebovat..
    quantity = SmallIntegerField(null=False, blank=False)


class Banners(Model):
    image = ImageField(upload_to='images/banners/')
    text = CharField(max_length=256)

    def __str__(self):
        return self.text

    def image_tag(self):
        return mark_safe('<img src="%s" width="80" />' % (self.image.url))

warehouse/views.py
from datetime import datetime, timedelta, time

from django.db.models import Sum
from django.shortcuts import render

# Create your views here.
from django.urls import reverse_lazy, reverse
from django.views.generic import TemplateView, CreateView, DetailView, ListView

from warehouse.forms import ReservationForm, ReservationItemsForm
from warehouse.models import TimeTable, Reservation, Item, Manufacturer, Category

from django.conf import settings
from django.core.mail import send_mail


class IndexView(TemplateView):
    """ Home page. """
    template_name = "index.html"


class WeekTableView(TemplateView):
    """ Timetable for reservation. """
    template_name = 'week_table.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        # for how many weeks do you need a reservation
        context['max_week'] = 3
        context['current_week'] = int(self.request.GET.get('week_number', 0))
        context['prev_week'] = context['current_week'] - 1
        context['next_week'] = context['current_week'] + 1

        # setting a day
        dateshift = 7 * context['current_week']
        today = datetime.today().date()
        day_1 = today + timedelta(days=dateshift)
        day_7 = today + timedelta(days=7+dateshift)
        current_date = day_1

        # Creating a timetable for reservation

        # names of days in first row (creating a variable header)
        header = []
        for _ in range(7):
            header.append({
                "name": current_date.strftime('%d-%m-%y%n\n%A%n'),
                "date": current_date
                })
            current_date += timedelta(days=1)

        # sum of reservation for current week (creating a variable week_reservations)
        week_reservations = Reservation.objects.filter(
            timeslot__date__gte=day_1,
            timeslot__date__lte=day_7,
            ).values('timeslot__date', 'timeslot__start_time'
            ).annotate(route_sum=Sum('route_numbers')
            ).values('route_sum', 'timeslot__date', 'timeslot__start_time')

        # values from timetable for current week (creating a variable timetable)
        timetable = TimeTable.objects.filter(
            date__gte=day_1,
            date__lte=day_7,
        )

        # variables for holding values for every cell in timetable for current_week
        week_map = {}
        week_capacity = {}

        # add every event from timetable for current_week (variable timetable) to new variable (week_map)
        # select necessary values (event.date and event.start_time)
        for event in timetable:
            week_map[(event.date, event.start_time)] = event

        # add every event from week_reservation for current_week (variable week_resertvations)
        # to new variable (week_capacity)
        # select necessary values
        for space in week_reservations:
            week_capacity[(space['timeslot__date'], space['timeslot__start_time'])] = space['route_sum']

        # hours range
        start_hour = 6
        end_hour = 23

        # names of hours in first column (setting a step -> 2 hours) -> current hour
        # (creating a variable rows)
        rows = []
        for hour in range(start_hour, end_hour, 2):
            current_hour = time(hour=hour, minute=0)

            # create a variable days (holding values for cell - date, timetable, capacity)
            days = []
            for current_date in header:
                day = {
                    "date": "",
                    "timetable": week_map.get(
                        (current_date["date"], current_hour), None
                    ),
                    "capacity": week_capacity.get(
                        (current_date["date"], current_hour), 0
                    ),
                }
                days.append(day)

            rows.append({
                "hour": current_hour.strftime("%H:%M"),
                "days": days
            })

        context.update({
            "header": header,
            "rows": rows
        })

        return context


class ReservationCreateView(CreateView):
    """ Create reservation """
    template_name = 'reservation.html'
    form_class = ReservationForm
    success_url = reverse_lazy('warehouse:item_reservation')

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['timetable'] = TimeTable.objects.filter(
            date=self.kwargs['requested_date'],
            start_time=self.kwargs['requested_time']
        ).first()
        context['capacity'] = context['timetable'].reservations.aggregate(Sum('route_numbers'))['route_numbers__sum']
        return context

    def get_initial(self):
        init_data = super().get_initial()
        init_data['timeslot'] = TimeTable.objects.filter(
            date=self.kwargs['requested_date'],
            start_time=self.kwargs['requested_time']
        ).first()
        return init_data

    def get_form_kwargs(self):
        kwargs = super(ReservationCreateView, self).get_form_kwargs()
        req_time = TimeTable.objects.filter(
            date=self.kwargs['requested_date'],
            start_time=self.kwargs['requested_time']
        ).first()
        occupied_ropes = req_time.reservations.aggregate(Sum('route_numbers'))['route_numbers__sum']
        if occupied_ropes is None:
            occupied_ropes = 0
        full_capacity = req_time.capacity
        choice = (full_capacity - occupied_ropes)
        choices = [x for x in range(1, choice+1)]  # tuple(map(lambda x: (int(x), int(x)), choices))
        kwargs['route_numbers'] = tuple(map(lambda x: (int(x), int(x)), choices))
        return kwargs

    def get_success_url(self):
        return reverse(
            'warehouse:item_reservation',
            kwargs={'reservation': self.object.id}
        )


class ReservationItemsCreateView (CreateView):
    """ Add Item to a reservation. """
    template_name = 'warehouse.html'
    form_class = ReservationItemsForm
    success_url = reverse_lazy('warehouse:reservation_success')

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['reservation'] = Reservation.objects.filter(
            id=self.kwargs['reservation'],
        ).first()
        return context

    def get_initial(self):
        init_data = super().get_initial()
        init_data['reservation'] = Reservation.objects.filter(
            id=self.kwargs['reservation'],
        ).first()
        return init_data

    def get_success_url(self):
        return reverse(
            'warehouse:reservation_success',
            kwargs={'reservation': self.object.reservation.id})


class SuccessView (TemplateView):
    """ Reservation confirmation - email. """
    template_name = "reservation_success.html"
    model = Reservation
    reservation_information = []

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['this_reservation'] = Reservation.objects.filter(
            id=self.kwargs['reservation'],
        ).first()

        subject = f'Reservation confirmation ({context["this_reservation"].timeslot})'
        message = f'Hi {context["this_reservation"].first_name} {context["this_reservation"].last_name}, ' \
                  f' thank you for your reservation for {context["this_reservation"].person_quantity} people ' \
                  f'({context["this_reservation"].route_numbers} rope/s) for {context["this_reservation"].timeslot}.' \
                  f'If you need to change or cancel your reservation call to +420 732 732 751.'
        email_from = 'rosta.filip@email.cz'
        recipient_list = [context["this_reservation"].email]
        # currently with # to stop sending emails during WIP...
        # send_mail(subject, message, email_from, recipient_list, fail_silently=False)
        return context


class RentalViewFilter(ListView):
    """ Rental - review page. """
    model = Item
    template_name = 'rental_review.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['item_list'] = Item.objects.all()
        context['manufacturer_list'] = Manufacturer.objects.all()
        context['category_list'] = Category.objects.all()

        context['current_manufacturer'] = int(self.request.GET.get('manufacturer_select', 0))
        context['current_category'] = int(self.request.GET.get('category_select', 0))

        context['current_manufacturer_name'] = Manufacturer.objects.filter(
            id=int(context['current_manufacturer']))
        context['current_category_name'] = Category.objects.filter(
            id=int(context['current_category']))

        context['manufacturer_filter_list'] = Item.objects.filter(manufacturer=context['current_manufacturer'])
        context['category_filter_list'] = Item.objects.filter(category=context['current_category'])
        context['combination_filter_list'] = Item.objects.filter(manufacturer=context['current_manufacturer']).filter(category=context['current_category'])

        return context


class RentalDetailView (DetailView):
    """ Rental - detailed information about product. """
    model = Item
    template_name = 'rental_detail.html'
    queryset = Item.objects.all()

templates/base.html
{% load static %}

<html {% if LANGUAGE_CODE %}lang="{{ LANGUAGE_CODE }}"{% endif %}>

<!-- Favicon -->
<link rel="shortcut icon" type="image/png" href="{% static 'favicon/favicon.ico' %}"/>

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>LSV - Ledova stena Vir</title>

    <!-- CSS -->
    <link rel="stylesheet"
          href="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css"
          integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS"
          crossorigin="anonymous">
    <link rel="stylesheet" href="{% static 'base.css' %}">

    <!-- JavaScript -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
            integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
            crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.6/umd/popper.min.js"
            integrity="sha384-wHAiFfRlMFy6i5SRaxvfOCifBUQy1xHdJ/yoi7FRNXMRBu5WHdZYu1hA6ZOblgut"
            crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/js/bootstrap.min.js"
            integrity="sha384-B0UglyR+jN6CkvvICOB2joaf5I4l3gm9GU6Hc1og6Ls7i6U/mkkaduKaBhlAXv9k"
            crossorigin="anonymous"></script>
    <script src="{% static 'timetable.js' %}"></script>

    <!-- DATATABLES -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.25/css/jquery.dataTables.min.css">
    <script src="//cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>

    <!-- Font -->
    <link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">

</head>

<body class="d-flex flex-column min-vh-100">

<header>
    <nav class="navbar navbar-expand-lg visited" style="background-color:#131941; color:#f5f5dc">
        <div class="container fixed">
            <a class="navbar-brand" href="{% url 'index' %}"><img src="{% static 'images/logo_1.png' %}"
                                                                  alt="logo"/></a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup">
                <img src="{% static 'images/burger_p.png' %}" alt="burger"/>
            </button>
            <div class="collapse navbar-collapse" id="navbarNavAltMarkup">

                {# --- home --- #}
                <div class="navbar-nav">
                    <h1 class="text-uppercase header">
                        <a class="nav-item nav-link active" href="{% url 'index' %}">Home</a>
                    </h1>
                </div>

                {# --- time table --- #}
                <div class="navbar-nav">
                    <h1 class="text-uppercase header">
                        <a class="nav-item nav-link active" href="{% url 'warehouse:week_table' %}">Time-table</a>
                    </h1>
                </div>

                {# --- rental review --- #}
                <div class="navbar-nav">
                    <h1 class="text-uppercase header">
                        <a class="nav-item nav-link active" href="{% url 'warehouse:rental_list' %}">Rental review</a>
                    </h1>
                </div>
            </div>
        </div>
    </nav>
</header>

<main>
    <div class="container">
        {% block content %}{% endblock %}
    </div>
</main>

<div class="wrapper flex-grow-1"></div>

<footer style="color:#f5f5dc; background-color:#4e4e4e; padding-bottom: 10px">

    <div class="container" style="padding-top: 15px; horiz-align: center">
            <div>
                <h2 class="text-uppercase header">Partners:</h2>
            </div>
    </div>

    <div class="container">
            <div class="row">
                <div class="col-md-4 mb-md-0 mb-4" style="padding-right: 30px; text-align: center">
                    <a href="https://grivel.com/"><img class="foot-image" src="{% static 'images/logo_grivel_p.png' %}" alt="Grivel"/></a>
                </div>

                <div class="col-md-4 mb-md-0 mb-4" style="padding-right: 30px; text-align: center">
                    <a href="https://www.petzl.com/"><img class="foot-image" src="{% static 'images/logo_petzl_white_p.png' %}" alt="Petzl"/></a>
                </div>

                <div class="col-md-4 mb-md-0 mb-4" style="padding-right: 30px; text-align: center">
                    <a href="https://www.singingrock.cz/"><img class="foot-image" src="{% static 'images/logo_singingrock_p.png' %}" alt="Singingrock"/></a>
                </div>
            </div>
    </div>
        <div class="container" style="padding-top: 15px; horiz-align: center">
    </div>

    <div class="container">
        <div class="row">
            <div class="col-md-3 mb-md-0 mb-3">
                <h2 class="text-uppercase font-weight-bold header">Contacts:</h2>
                <h5 class="header">Ledová stěna Vír z.s.</h5>
                <h5 class="header">Palackého 1585/16</h5>
                <h5 class="header">678 01 Blansko</h5>
            </div>

            <div class="col-md-3 mb-md-0 mb-3">
                <h2 class="text-uppercase font-weight-bold header">Information:</h2>
                <h5 class="header">Tel.: +420 732 732 751</h5>
                <h5 class="header">Email: info@ledovastenavir.cz</h5>
                <h5 class="header"></h5>
            </div>

            <div class="col-md-3 mb-md-0 mb-3">
                <h2 class="text-uppercase font-weight-bold header">Climbing club:</h2>
                <h5 class="header">Tel.: +420 732 732 751</h5>
                <h5 class="header"></h5>
                <h5 class="header"></h5>
            </div>

            <div class="col-md-3 mb-md-0 mb-3">
                <h2 class="text-uppercase font-weight-bold header">Club:</h2>
                {% if user.is_authenticated %}
                <a href="{% url 'logout' %}"><h5 class="header">Log Out</h5></a>
                <a href="{% url 'accounts:my_account' %}"><h5 class="header">Account</h5></a>
                <a href="{% url 'club:club' %}"><h5 class="header">Club</h5></a>
                <h5 class="header"></h5>
                {% else %}
                <a href="{% url 'login' %}"><h5 class="header">Log In</h5></a>
                <a href="{% url 'accounts:registration' %}"><h5 class="header">Registration</h5></a>
                <h5 class="header"></h5>
                {% endif %}
            </div>
        </div>
  </div>

</footer>

</body>

</html>

templates/rental_review_card.html
{% load static %}
<a class="black" id="item_view" href="{% url 'warehouse:rental_detail' item.pk %}">
<div class="wrapper">
    <div class="card-sl flex-container" >
        <div class="card-heading">
            {{ item.manufacturer.m_name }}
        </div>
        <div class="card-heading font-weight-bold text-uppercase" >
            {{ item.name }} ({{ item.category }})
        </div>
        <div class="card-image">
            {% if item.image %}
                <img src="{{ item.image.url }}" class="card-img-top" alt="Item image">
            {% endif %}
        </div>
        <div class="card-text">
            <p>{{ item.stock }} pieces</p>
            <p>{{ item.price }} CZK </p>
        </div>
    </div>
</div>
</a>

templates/reservation_preview.html
<head>
    <title>LSV - Rezervace</title>
</head>

{% extends 'base.html' %}

{% block content %}
<div class="jumbotron" style="background-color:#d2ecff">
    {% if timetable %}
        <h2>{{ timetable.date }} {{ timetable.start_time }} - {{ timetable.end_time }}</h2>
        <h3> Total capacity: {{ timetable.capacity }}</h3>
        <h3> Temporary occupied capacity: {{ capacity }} </h3>
            <a class="btn btn-primary" href="{% url 'warehouse:reservation_create' timetable.date timetable.start_time %}" >Make reservation</a>
            <a class="btn btn-primary" href="{% url 'warehouse:week_table' %}" >Cancel</a>
    {% else %}
        <h3> There is nothing for this combination of date and time</h3>
    {% endif %}
</div>
{% endblock %}

templates/reservation_success.html
<head>
    <title>LSV - Reservation success</title>
</head>

{% extends 'base.html' %}

{% block content %}
    <div class="jumbotron" style="background-color:#d2ecff">
        <h2>Your reservation has been successfully created.</h2>
        <h3>Confirmation of your reservation ({{ this_reservation.timeslot }}) was send to your email ({{ this_reservation.email }}).</h3>
        <a class="btn btn-primary" href="{% url 'index' %}">Back to home</a>
    </div>
{% endblock %}

templates/warehouse.html
<head>
    <title>LSV - Rental</title>
</head>

{% extends 'base.html' %}

{% block content %}
<div class="jumbotron" style="background-color:#d2ecff">
    <form method="POST">
    {% csrf_token %}
    <table>{{ form }}</table>
    <input type="submit" value="borrow" class="btn btn-primary">
    <a class="btn btn-primary" href="{% url 'warehouse:reservation_success' reservation.id %}" >No item's needed.</a>
    </form>
</div>
{% endblock %}

templates/week_table.html
<head>
    <title>LSV - Timetable</title>
</head>

{% extends "base.html" %}
{% load static %}

{% block content %}
<div class="jumbotron" style="background-color:#d2ecff; padding: 2rem 2rem 4rem 2rem">
    <main>
        {% if current_week == 0 %}
            <h1>Reservation timetable for this Week.</h1>
        {% elif current_week == 1 %}
            <h1>Reservation timetable for next week.</h1>
        {% else %}
            <h1>Reservation timetable for next {{ current_week }} weeks.</h1>
        {% endif %}

        <div class="container">
            <table id="id-tab-timetable" class="display" style="width:100%">
                {# days of week #}
                <thead>
                <tr>
                    <th><img src="{% static 'favicon/favicon-32x32.png' %}" alt="logo_small_timetable"/></th>
                    {% for row in header %}
                        <th class="inside"> {{ row.name }} </th>
                    {% endfor %}
                </tr>
                </thead>
                {# hours of day #}
                <tbody>
                {% for hour in rows %}
                    <tr>
                        <td>{{ hour.hour }}</td>
                        {% for item in hour.days %}

                            {% if item.timetable %}
                                {% with dd=item.timetable.date|date:'Y-m-d' tt=item.timetable.start_time|time:'H:i' cc=item.capacity%}

                                    {% if item.capacity == item.timetable.capacity %}
                                    <td class="inside_full" id="timetable-cell-occupied" >
                                        <p class="table">Start: {{ item.timetable.start_time |time:'H:i' }}</p>
                                        <p class="table">End: {{ item.timetable.end_time|time:'H:i' }}</p>
                                        <p class="table">Occupied</p>
                                    </td>

                                    {% else %}
                                    <td class="inside" id="timetable-cell" data-link="{% url 'warehouse:reservation_create' dd  tt cc %}">
                                        <!-- <p> Date: {{ item.timetable.date |date:'d-m-Y' }}</p> -->
                                        <p class="table">Start: {{ item.timetable.start_time |time:'H:i' }}</p>
                                        <p class="table">End: {{ item.timetable.end_time|time:'H:i' }}</p>
                                        <p class="table">Cap.: {{ item.capacity }} / {{ item.timetable.capacity }}</p>
                                    </td>
                                    {% endif %}
                                {% endwith %}

                            {% else %}
                                <td class="inside_full"> <img  src="{% static 'images/logo_timetable.png' %}" alt="logo_timetable"/> </td>
                            {% endif %}
                        {% endfor %}
                    </tr>
                {% endfor %}
                </tbody>
            </table>
        </div>


        {% if current_week != 0 %}
            <a class="btn btn-primary"
               href="{% url 'warehouse:week_table' %}?week_number={{ prev_week }}">Back</a>
        {% endif %}

        {% if current_week < max_week %}
            <a class="btn btn-primary"
               href="{% url 'warehouse:week_table' %}?week_number={{ next_week }}"
               style="float: right">Next</a>
        {% else %}
            <a class="btn btn-primary"
               href="{% url 'warehouse:week_table' %}?week_number=0"
               style="float: right">Back to present week</a>
        {% endif %}
    </main>
</div>
{% endblock %}